<?php
App::uses('QueueTask', 'Queue.Console/Command/Task');

class QueueUpdateRatingsTask extends QueueTask {

	public function add() {
		$QueuedTask = EvClassRegistry::init('Queue.QueuedTask');
		$QueuedTask->createJob('UpdateRatings');
	}

	public function run($data, $id = null) {

		$feefo = new Evoluted\Feefo\Feefo(
			Configure::read('EvFeefo.merchantIdentifier'),
			Configure::read('EvFeefo.apiKey')
		);

		$Rating = EvClassRegistry::init('EvFeefo.Rating');

		$Rating->deleteAll(['1 = 1']);

		$pages = 5;

		$data = [];

		for($i=1;$i<=$pages; $i++) {

			$ratings = $feefo->get('10/products/ratings', [
				'merchant_identifier' => $feefo->merchantIdentifier,
				'page_size' => '100',
				'page' => $i,
				'since' => 'year'
			]);


			if (! empty($ratings)) {
				foreach ($ratings->products as $rating) {
		            $data[] = [
		                'vendor_ref ' => $rating->vendor_ref,
		                'rating' => (! empty($rating->rating) ? $rating->rating : null)
		            ];
		        }
			}
		}

		$Rating->saveMany($data);

		$nextDate = new DateTime();
		$nextDate->add(new DateInterval('P1D'));
		$QueuedTask = EvClassRegistry::init('Queue.QueuedTask');
		$QueuedTask->createJob('UpdateRatings', null, $nextDate->format('Y-m-d H:i:s'));

		return true;


	}
}
